unit btnSMSExampleForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, btnsms;

type
  TBtnSMSExample = class(TForm)
    buttonSendMessage: TButton;
    labelErrorCode: TLabel;
    labelErrorMessage: TLabel;
    editDestination: TEdit;
    editText: TEdit;
    labelDestination: TLabel;
    labelText: TLabel;
    editUsername: TEdit;
    editPassword: TEdit;
    labelUsername: TLabel;
    labelPassword: TLabel;
    buttonGetUserstatus: TButton;
    procedure buttonSendMessageClick(Sender: TObject);
    procedure buttonGetUserstatusClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  BtnSMSExample: TBtnSMSExample;

implementation

{$R *.DFM}

procedure TBtnSMSExample.buttonSendMessageClick(Sender: TObject);
var
   creds, msg, result :Pointer;
   username, password, destination, text :PChar;
   errorcode :Integer;

begin

     { convert Pascal-strings into PChar's }
     username := PChar(editUsername.Text);
     password := PChar(editPassword.Text);
     destination := PChar(editDestination.Text);
     text := PChar(editText.Text);

     { build the SMS message }
     creds := btnCredsNew(username,password);
     msg := btnSmsNew();
     btnSmsSetCreds(msg,creds);
     btnSmsAddDestination(msg,destination,StrLen(destination));
     btnSmsSetText(msg,text,StrLen(text));

     { send the SMS }
     result := btnSmsSend(msg);

     { do some error reporting }
     errorcode := btnResultGetErrorcode(result);
     labelErrorcode.Caption := 'Error Code: '+IntToStr(errorcode);
     if errorcode <> BTN_ERROR_SUCCESS then
     begin
          labelErrorMessage.Caption := 'Error Message: '+string(btnResultGetErrorMsg(result));
     end;

     { free all structures }
     btnSmsFree(msg);
     btnResultFree(result);
     btnCredsFree(creds);
end;

procedure TBtnSMSExample.buttonGetUserstatusClick(Sender: TObject);
var
   username, password :PChar;
   creds, status :Pointer;
   summary :String;
   
begin
     { convert Pascal-strings into PChar's }
     username := PChar(editUsername.Text);
     password := PChar(editPassword.Text);

     { do the userstatus request }
     creds := btnCredsNew(username,password);
     status := btnUserstatusRequest(creds);

     { build a result string }
     summary := 'Userstatus Request - ';
     if btnUserstatusGetErrorcode(status) = BTN_ERROR_SUCCESS then
      { request was successful - errorcodes are not shown }
      begin
          if btnUserstatusGetActive(status) = 1 then
             summary := summary + 'Account is active - '
          else
             summary := summary + 'Account is inactive - ';
          summary := summary + 'Type ' + IntToStr(btnUserstatusGetType(status)) + ' - ';
          summary := summary + 'Account Balance ' + String(btnUserstatusGetAccountBalance(status)) + ' - ';
          summary := summary + 'Sent Today ' + IntToStr(btnUserstatusGetToday(status)) + ' - ';
          summary := summary + 'Daily Limit ' + IntToStr(btnUserstatusGetLimit(status));
      end
     else
      { request was unsuccessful - show the errorcode and message }
      begin
           summary := summary + 'Errorcode ' + IntToStr(btnUserstatusGetErrorcode(status)) + ' - ';
           summary := summary + 'ErrorMessage ' + String(btnUserstatusGetErrorMsg(status));
      end;

     { show a message box with the result }
     Application.MessageBox(PChar(summary),'Userstatus Result', MB_OK);

     { free the strcutures }
     btnCredsFree(creds);
     btnUserstatusFree(status);
end;

end.
